#!/usr/local/bin/perl
use strict;
use Win32::Autoglob;
use GD;
use Math::Trig;
use POSIX qw(floor ceil);
sub round{ floor($_[0] + 0.5) }
++$|;
GD::Image->trueColor(1);



# IvV̏
#------------------------------------------------------------------//
use Getopt::Std;
getopts('?hfsta:d:m:',\%ARGV);

my $DEGREE		= $ARGV{a} || 140;	# ؂opx̃ftHg 140
my $DIAGONAL	= $ARGV{d} || 0;	# ΊpჂ[h;
my $TEST		= $ARGV{t} || 0;	# eXg[hiۑȂj;
my $FAST		= $ARGV{f};			# 蔲[h
my $MODE		= $ARGV{m} || 0;	# 0:EDP 2:OGP 3:ESAP 3:SGP
my @PROJ	= qw(	equidistant-projection
					orthographic-projection
					equisolidangle-projection
					stereographic-projection	);
sub noise{ $ARGV{s} or printf @_ }	# ro߂\



# wv
#------------------------------------------------------------------//
if(@ARGV == 0 or $ARGV{h} or $ARGV{'?'}){
print "usage: $0 [-fsta:d:m:] file(s)\n";
print '  $Id: fisheye.pl,v 1.29 2004/03/21 16:55:15 dune Exp dune $';
print "\n";
exit;
}



# O[oϐ
#------------------------------------------------------------------//
our($VERSION) = q($Revision: 1.29 $) =~ m/\s([\d.]+)\s/;
my $gWIDTH;		# 摜̕
my $gHEIGHT;	# 摜̍
my $gBLACK;		# 
my $gBOUND;		# o͉摜̔



# XNvg͓̓t@C
#------------------------------------------------------------------//
foreach my $file (@ARGV){

	# ͉摜J
	my $img = GD::Image->new($file) or die qq/$file : $!\n/;
	($gWIDTH,$gHEIGHT) = $img->getBounds();
	noise("%s %d[dot] x %d[dot]\n", $file,$gWIDTH,$gHEIGHT);
	noise("  mode     : %d %s\n",$MODE,$PROJ[$MODE]);
	$gBLACK = $img->colorResolve(0,0,0);

	# aƒS߂
	my($radius,$ox,$oy);
	
	if($DIAGONAL){
		if($DIAGONAL =~ m/^[.\d]+$/){		# a𒼐ڎw肷
			($radius,$ox,$oy) = ($DIAGONAL/2,0,0);
			$gBOUND = round($radius);
		}else{								# Ίp𒼌aƂ
			($radius,$ox,$oy)
				= (sqrt($gWIDTH*$gWIDTH+$gHEIGHT*$gHEIGHT)/2,0,0);
			$gBOUND = round($gWIDTH / 2);
			if($DIAGONAL =~ m/^([.\d]+)[%P]$/){ $radius *= ($1/100) }
		}
	}else{									# v
		($radius,$ox,$oy) = get_r($img);
		$gBOUND = round($radius);
	}

	# ̕\
	(my $file_out = $file)
		=~ s/^(.*[\\\/])?(.+?)(\.\w+)$/$1defished-$2.jpeg/;
	if($file_out eq $file){
		print qq/$file : Can't name output file\n/;  next;
	}
	
	noise("  diameter : %s [dot]  %d [%]\n",
	round(200*$radius)/100,
	round(20000*$radius/sqrt($gWIDTH*$gWIDTH+$gHEIGHT*$gHEIGHT))/100);
	noise("  center x : %+.2lf [dot]\n",round(100*$ox)/100);
	noise("  center y : %+.2lf [dot]\n",round(100*$oy)/100);
	noise("  region   : %s [degree]\n",$DEGREE);
	noise("  output   : %s\n",$file_out);
	if($FAST){
	noise("  warning  : fast mode, picture quality degraded!\n");
	}

	# ␳摜̍쐬ia $radius p $DEGREE ɑj
	my $img_out = new GD::Image(2*$gBOUND,2*$gBOUND);

	for(my $i = 0; $i < $img->colorsTotal(); ++$i){
		$img_out->colorAllocate( $img->rgb($i) );
	}

	$img_out->fill(0,0,$gBLACK);
	my($a,$b,$c);
	if($MODE == 0){
		# EDP
		$a = 2 / pi * $radius;
		$b = 1;
	}elsif($MODE == 1){
		# OGP
		$a = sqrt(2) * $radius;;
		$b = 0.5;
	}elsif($MODE == 2){
		# ESAP
		$a =  $radius;
		$b = 1;
	}elsif($MODE == 3){
		# SGP
		$a = $radius;
		$b = 0.5;
	}

	$c = tan( deg2rad($DEGREE) / 2 ) / $radius;
	noise("\r  process  : %3d[%%]",0);

	for(my $y = 0; $y <= $gBOUND; ++$y){
		noise("\r  process  : %3d[%%]",round( 100*$y/$gBOUND ));
		for(my $x = 0; $x <= $gBOUND; ++$x){
			my $r = sqrt($x*$x+$y*$y);
			my($x0,$y0) = ($x,$y);

			if($r){
				my $k;
				if($MODE == 0){
					$k = $a * $b * atan($c * $r) / $r;
				}elsif($MODE == 1 or $MODE == 2){
					$k = $a * sin( $b * atan($c * $r) ) / $r;
				}elsif($MODE == 3){
					$k = $a * tan( $b * atan($c * $r) ) / $r;
				}
				$x0 *= $k;
				$y0 *= $k;
			}

			cp_pxl([$img,+$x0+$ox,+$y0+$oy]=>[$img_out,+$x,+$y]);
			cp_pxl([$img,+$x0+$ox,-$y0+$oy]=>[$img_out,+$x,-$y]);
			cp_pxl([$img,-$x0+$ox,+$y0+$oy]=>[$img_out,-$x,+$y]);
			cp_pxl([$img,-$x0+$ox,-$y0+$oy]=>[$img_out,-$x,-$y]);
		}
	}
	noise("\r  process  : %3d[%%]",100);

	# ۑ
	if(!$TEST){
		open(FILE,">",$file_out) or die qq/$file_out : $!\n/;
		binmode FILE;
		print FILE $img_out->jpeg($FAST ? 80 : 100);
	}
	noise("\n");
}
exit 0;



# ͉摜̉~`ʖ̔aƒS߂B
#------------------------------------------------------------------//
sub get_r{
	my $img = shift;
	my($w_start,$w_end) = ($gWIDTH,0);
	my($h_start,$h_end) = ($gHEIGHT,0);

	my(@blk1) = $img->rgb($img->getPixel(0,0));
	my(@blk2) = $img->rgb($img->getPixel($gWIDTH-1,0));
	my(@blk3) = $img->rgb($img->getPixel(0,$gHEIGHT-1));
	my(@blk4) = $img->rgb($img->getPixel($gWIDTH-1,$gHEIGHT-1));
	my $R = (sort{$b <=> $a}($blk1[0],$blk2[0],$blk3[0],$blk4[0]))[0];
	my $G = (sort{$b <=> $a}($blk1[1],$blk2[1],$blk3[1],$blk4[1]))[0];
	my $B = (sort{$b <=> $a}($blk1[2],$blk2[2],$blk3[2],$blk4[2]))[0];
	
	for(my $j = 0; $j < $gHEIGHT; ++$j){
		for(my $i = 0; $i < $gWIDTH; ++$i){
			my($r,$g,$b) = $img->rgb($img->getPixel($i,$j));
			next if($r <= $R or $g <= $G or $b <= $B);
			if($i < $w_start){	$w_start = $i	}
			elsif($w_end < $i){	$w_end = $i		}
			if($j < $h_start){	$h_start = $j	}
			elsif($h_end < $j){	$h_end = $j		}
		}
	}

	if($TEST){
		noise("    w(s e) : ",$w_start," ",$w_end,"\n");
		noise("    h(s e) : ",$h_start," ",$h_end,"\n");
	}

	my $r = ($w_end + $h_end - $w_start - $h_start) / 4;
	my $w = ($w_end + $w_start - $gWIDTH) / 2;
	my $h = ($h_end + $h_start - $gHEIGHT) / 2;

	if($gHEIGHT < $w_end - $w_start){		# ㉺؂Ă
		$r = ($w_end - $w_start) / 2;
		$w = 0;
	}elsif($gWIDTH < $h_end - $h_start){	# E؂Ă
		$r = ($h_end - $h_start) / 2;
		$h = 0;
	}
	
	return($r,+$w,-$h);	# aCS x,y
}



# ʒu (x,y) ̐F $color ߂
#------------------------------------------------------------------//
sub get_pxl{
	my($img,$x,$y) = @_;

	# _Ɉړ
	my $ix = $x + $gWIDTH/2;
	my $iy = $gHEIGHT/2 - $y;

	my $color;

	if($ix < 0 or $gWIDTH <= $ix or $iy < 0 or $gHEIGHT <= $iy){
		$color = $gBLACK
	}elsif($FAST){
		# ľܓ
		my $rx = round $ix;
		my $ry = round $iy;
		return $img->rgb( $img->getPixel($rx,$ry) );
	}else{
		my $floor_ix = floor $ix;
		my $floor_iy = floor $iy;
	
		# l̉fĂ
		my @a = $img->rgb($img->getPixel( $floor_ix,$floor_iy ));
		my @b = $img->rgb($img->getPixel( ceil($ix),$floor_iy ));
		my @c = $img->rgb($img->getPixel( $floor_ix,ceil($iy) ));
		my @d = $img->rgb($img->getPixel( ceil($ix),ceil($iy) ));

		# Ԉʒu 0`1
		my $px = $ix - $floor_ix;
		my $py = $iy - $floor_iy;

		# ⊮
		my $r = interp($a[0],$b[0],$c[0],$d[0],$px,$py);
		my $g = interp($a[1],$b[1],$c[1],$d[1],$px,$py);
		my $b = interp($a[2],$b[2],$c[2],$d[2],$px,$py);

		# pbgɓo^
		return($r,$g,$b);
	}
}



# ʒu (x,y) ɐF $color vbg
#------------------------------------------------------------------//
sub set_pxl{
	my($img,$x,$y,$r,$g,$b) = @_;
	my $i = $x + $gBOUND;
	my $j = $gBOUND - $y;
	$img->setPixel($i,$j,$img->colorResolve($r,$g,$b));
	return $img;
}



# ʒu from ̐Fʒu to ɃRs[
#------------------------------------------------------------------//
sub cp_pxl{
	my($from,$to) = @_;
	set_pxl(@{$to},get_pxl(@{$from}));
}



# S_𒼐⊮
#------------------------------------------------------------------//
sub interp{
	my($a,$b,$c,$d,$p,$q) = @_;
	my $x	= (1-$p) * ($a * (1-$q) + $c*$q)
			+    $p  * ($b * (1-$q) + $d*$q);
	return round $x;
}

__END__
